void clear_screen(unsigned char color)
{
	memset(textBuf,32,sizeof(textBuf));
	memset(attrBuf,color,sizeof(attrBuf));
}



int put_str(int x,int y,const char* str,unsigned char col)
{
	unsigned char c;
	int xs;

	xs = x;

	while(1)
	{
		c=*str++;

		if(!c) break;

		switch(c)
		{
		case '~':
			{
				col=((col<<4)&0xf0)|((col>>4)&0x0f);
				continue;
			}
			break;

		default:
			PUT_CHAR_ATTR(x,y,c,col);
			++x;
		}
	}

	return x - xs;
}



void put_str_file(int x,int y,const char* str,unsigned char col)
{
	unsigned char c;

	while(1)
	{
		c=*str++;

		if(x>=textScreenWidth||!c) break;

		if(c<32||c>=128) c='?';

		PUT_CHAR_ATTR(x,y,c,col);

		++x;
	}
}



void put_num(int x,int y,int num,int digit)
{
	int i;

	for(i=0;i<digit;++i) PUT_CHAR(x+i,y,NUM2DECZ(num,digit-1-i));
}



void put_num_attr(int x,int y,int num,int digit,unsigned char color)
{
	int i;

	for(i=0;i<digit;++i) PUT_CHAR_ATTR(x+i,y,NUM2DECZ(num,digit-1-i),color);
}



inline unsigned char cursor_color(int row,int rowhl,int column)
{
	int x1,x2,y1,y2;
	unsigned char color;

	if(row==curRow&&column==curColumn) return COL_CURSOR;

	if(!(rowhl%module.measure)) color=COL_PATTERN_BEAT; else color=COL_PATTERN_BACKGROUND;

	if(curSelectionXS>=0)
	{
		if(curSelectionXS<curSelectionXE)
		{
			x1=curSelectionXS;
			x2=curSelectionXE;
		}
		else
		{
			x1=curSelectionXE;
			x2=curSelectionXS;
		}

		if(curSelectionYS<curSelectionYE)
		{
			y1=curSelectionYS;
			y2=curSelectionYE;
		}
		else
		{
			y1=curSelectionYE;
			y2=curSelectionYS;
		}

		if(column>=x1&&column<=x2&&row>=y1&&row<=y2)
		{
			if(!(row%module.measure)) color=COL_SELECTION_BEAT; else color=COL_SELECTION;

			if(row==curRow) color=COL_SELECTION_CURSOR;

			return color;
		}
	}

	if(row==curRow) color=COL_CURSOR_ROW;

	return color;
}



int get_pattern_top_row_2x(void)
{
	int row, hgt, rcnt, first_row, last_row;

	if (editStyle == EDIT_STYLE_LINEAR)
	{
		first_row = 0;
		last_row = MAX_ROWS;
	}
	else
	{
		first_row = curRow * 2;

		while (first_row >= 0)
		{
			if (module.marker[first_row / 2])
			{
				first_row += 1;
				break;
			}

			first_row -= 2;
		}

		if (first_row < 0) first_row = 0;

		last_row = curRow;

		while (last_row < MAX_ROWS)
		{
			++last_row;

			if (module.marker[last_row]) break;
		}

		if (last_row > MAX_ROWS - 1) last_row = MAX_ROWS - 1;
	}

	hgt = PATTERN_HEIGHT;

	if (!hgt) hgt = 1;

	rcnt = PATTERN_HEIGHT / 2;
	row = curRow * 2;

	while (rcnt>0)
	{
		row -= 2;

		if (row < first_row) break;

		if (module.marker[row / 2]/*||row/2==songList[SongCur].length*/) --rcnt;

		--rcnt;
	}

	if (rcnt < 0) ++row;

	if (module.marker[curRow]) row += 2;

	if (row < first_row) row = first_row;

	if (row / 2 + PATTERN_HEIGHT + 1 >= last_row) row = (last_row - PATTERN_HEIGHT + 1) * 2;

	if (row < first_row) row = first_row;

	return row;
}



void draw_marker_name(int x, int y, int row, int color, bool ralign)
{
	int i, len;

	len = strlen(module.markerName[row]);

	if (!len) return;

	if (ralign) x -= len;

	for (i = 0; i < len; ++i) PUT_CHAR_ATTR(x + i, y, module.markerName[row][i], color);
}



void draw_pattern(void)
{
	int k,x,y,row,col,ct,row2x,rowhl,row2x_orig,rowhl_orig,row_display;
	unsigned char color,note,val;

	if(!module.columns) return;

	row2x_orig = get_pattern_top_row_2x();

	rowhl_orig = 0;

	for (row = 0; row<row2x_orig / 2; ++row)
	{
		if (module.marker[row]) rowhl_orig = 0;

		++rowhl_orig;
	}

	y=PATTERN_YPOS;

	row2x = row2x_orig;
	rowhl = rowhl_orig;

	while (y<(PATTERN_YPOS + PATTERN_HEIGHT))
	{
		x=PATTERN_XPOS;

		row = row2x / 2;

		if (row >= MAX_ROWS) break;
		
		if (!(row2x & 1))
		{
			if (editStyle == EDIT_STYLE_CHOPPED)
			{
				if (module.marker[row]) break;
			}
			else
			{
				if (row && (module.marker[row] || (module.loopEnd < MAX_ROWS - 1 && row == module.loopEnd)))
				{
					++y;
				}
			}
		}
		else
		{
			if (module.marker[row]) rowhl = 0;

			color = cursor_color(row, rowhl,-1);

			if (editStyle == EDIT_STYLE_LINEAR)
			{
				row_display = row;
			}
			else
			{
				if (!rowhl) row_display = row; else row_display = rowhl;
			}

			PUT_CHAR_ATTR(x + 0, y, (module.loopSupport&&row == module.loopStart) ? '>' : ' ', color);
			PUT_CHAR_ATTR(x + 1, y, NUM2DECZ(row_display, 3), color);
			PUT_CHAR_ATTR(x + 2, y, NUM2DECZ(row_display, 2), color);
			PUT_CHAR_ATTR(x + 3, y, NUM2DECZ(row_display, 1), color);
			PUT_CHAR_ATTR(x + 4, y, NUM2DECZ(row_display, 0), color);
			PUT_CHAR_ATTR(x + 5, y, (module.loopSupport&&row == module.loopEnd) ? '<' : ' ', color);

			x+=6;
			
			for (col = 0; col<module.columns; ++col)
			{
				ct = module.columnType[col];
				
				color = cursor_color(row, rowhl, col);
				
				switch(ct)
				{
				case COLUMN_TYPE_EMPTY:
					{
						PUT_CHAR_ATTR(x + 0, y, ' ', color);

						++x;
					}
					break;
				
				case COLUMN_TYPE_NOTE:
					{
						note = module.rows[row].column[col] & 127;

						PUT_CHAR_ATTR(x + 0, y, noteNames[note][0], color);
						PUT_CHAR_ATTR(x + 1, y, noteNames[note][1], color);
						PUT_CHAR_ATTR(x + 2, y, noteNames[note][2], color);

						x+=3;
					}
					break;

				default:
					{
						val = module.rows[row].column[col];

						for (k = 0; k<ct; ++k)
						{
							PUT_CHAR_ATTR(x + k, y, NUM2DEC(val, ct - 1 - k), color);
						}

						x += module.columnType[col];
					}
				}
			}
			
			draw_marker_name(x + 2, y, row, COL_MARKER_LIST, false);

			color = cursor_color(row, rowhl, -1);

			PUT_CHAR_ATTR(x, y, ' ', color);
			
			++y;
			++rowhl;
		}
		
		++row2x;
	}
}



void update_marker_list(void)
{
	int row;

	markerList.row[0] = 0;
	markerList.length = 1;
	markerList.cur = 0;

	for (row = 1; row < MAX_ROWS; ++row)
	{
		if (module.marker[row])
		{
			markerList.row[markerList.length++] = row;
		}

		if (row == curRow)
		{
			markerList.cur = markerList.length - 1;
		}
	}
}



void draw_marker_list(void)
{
	int i, x, y, off, row, color;
	
	update_marker_list();

	x = textScreenWidth - 5;
	y = PATTERN_YPOS;

	off = 0;

	if (markerList.length > PATTERN_HEIGHT)
	{
		off = markerList.cur - PATTERN_HEIGHT / 2;

		if (off < 0) off = 0;

		if (off >= markerList.length - PATTERN_HEIGHT) off = markerList.length - PATTERN_HEIGHT;
	}

	for (i = 0; i < PATTERN_HEIGHT; ++i)
	{
		row = markerList.row[off];

		if (markerList.cur == off) color = COL_PROGRAM_BACKGROUND; else color = COL_MARKER_LIST;

		PUT_CHAR_ATTR(x + 0, y, NUM2DECZ(row, 3), color);
		PUT_CHAR_ATTR(x + 1, y, NUM2DECZ(row, 2), color);
		PUT_CHAR_ATTR(x + 2, y, NUM2DECZ(row, 1), color);
		PUT_CHAR_ATTR(x + 3, y, NUM2DECZ(row, 0), color);
		
		draw_marker_name(x - 1, y, markerList.row[off], color, true);

		++y;
		++off;

		if (off >= markerList.length) break;
	}
}



int draw_menu_item(int x, char *str)
{
	x += put_str(x, textScreenHeight - 1, str, COL_HEADER);

	return x;
}



void draw_settings(void)
{
	int i,j,x,len;

	for(i=0;i<textScreenWidth;++i)
	{
		PUT_CHAR_ATTR(i,0,' ',COL_HEADER);
		PUT_CHAR_ATTR(i,textScreenHeight-1,' ',COL_HEADER);
	}
	
	put_str(0, textScreenHeight - 1, " Oct0 Spd00 Stp00", COL_HEADER);

	x = 20;

	if (!altMenu)
	{
		x = draw_menu_item(x, "~F1~Help");
		x = draw_menu_item(x, "~F2~Save");
		x = draw_menu_item(x, "~F3~Load");

		if(module.instruments) x = draw_menu_item(x, "~F4~Instr");

		x = draw_menu_item(x, "~F5~Play");
		x = draw_menu_item(x, "~F6~Info");
		x = draw_menu_item(x, "~F7~Engine");
		x = draw_menu_item(x, "~F8~Export");
	}
	else
	{
		x = draw_menu_item(x, (editStyle != EDIT_STYLE_CHOPPED)?"~F1~-Chop":"~F1~+Chop");

		x = draw_menu_item(x, !quietMode ? "~F2~-Quiet" : "~F2~+Quiet");

		x = draw_menu_item(x, "~F3~Zap");
		x = draw_menu_item(x, "~F10~Quit");
	}

	put_num(4 ,textScreenHeight-1,curOctave   ,1);
	put_num(9 ,textScreenHeight-1,module.speed,2);
	put_num(15,textScreenHeight-1,curAutoStep ,2);

	x=PATTERN_XPOS+6;

	if(!module.columns)
	{
		put_str(1,0,"Loading...",COL_HEADER);
		return;
	}

	put_str(0,0,engineHeader,COL_HEADER);

	for(i=0;i<module.columns;++i)
	{
		len=module.columnType[i];

		switch(len)
		{
		case COLUMN_TYPE_EMPTY: len=1; break;
		case COLUMN_TYPE_NOTE:  len=3; break;
		}
				
		if(module.columnChannel[i]>=0)
		{
			if(channelMute[module.columnChannel[i]])
			{
				for(j=0;j<len;++j) PUT_ATTR(x+j,0,COL_HEADER_MUTE);
			}
		}

		x+=len;
	}
	
	if(strlen(engineErrorMessage))
	{
		for (i = 0;i < textScreenWidth;++i) PUT_CHAR_ATTR(i, 0, ' ', COL_ERROR_BACKGROUND);

		put_str(5, 0, engineErrorMessage, COL_ERROR_BACKGROUND);

		put_str(1, 0, "~ESC~", COL_ERROR_BACKGROUND);
	}
}