vector<string> selectEngineFileList=vector<string>();
vector<string> selectEngineTitleList=vector<string>();
vector<string> selectEngineAboutList = vector<string>();

int selectEngineCount;
int selectEngineCursor;

char selectEngineTitle[128];
char selectEngineAbout[MAX_TEXT_WDT*MAX_TEXT_HGT];



void refresh_engine_list(void)
{
	char filename[MAXPATH];
	char engineDirectory[MAXPATH];
	FILE *file;
	DIR *dp;
	struct dirent *dirp;
	int y;

	strcpy(filename, baseDirectory);
	strcat(filename, "engines/list");

	strcpy(engineDirectory, baseDirectory);
	strcat(engineDirectory, "engines");

	file = fopen(filename, "wt");

	if (!file) return;

	y = screenHeight;

	if (dp = opendir(engineDirectory))
	{
		while ((dirp = readdir(dp)))
		{
			if (dirp->d_type == DT_REG)
			{
				if (!strcmp(&dirp->d_name[strlen(dirp->d_name) - strlen(ENGINE_EXTENSION)], ENGINE_EXTENSION))
				{
					if (y >= screenHeight)
					{
						clear_screen(COL_PROGRAM_BACKGROUND);

						put_str(1, 1, "Updating engine list...", COL_PROGRAM_BACKGROUND);

						y = 3;
					}

					put_str(3, y, dirp->d_name, COL_PROGRAM_BACKGROUND);

					++y;

					update_screen();

					if (engine_get_info(dirp->d_name))
					{
						fprintf(file, "%s\n", dirp->d_name);
						fprintf(file, "%s\n", selectEngineTitle);
						fprintf(file, "%s\n", selectEngineAbout);
						fprintf(file, "###\n");
					}
				}
			}
		}

		closedir(dp);
	}

	fclose(file);
}



void check_engine_updates(void)
{
	char hashname[MAXPATH],listname[MAXPATH],filename[MAXPATH], temp[1024];
	char engineDirectory[MAXPATH];
	char *hashPrev, *hashNew;
	int hashPrevSize, hashNewSize;
	FILE *file;
	DIR *dp;
	struct dirent *dirp;
	struct stat fileStat;
	bool refresh;

	hashPrev = NULL;
	hashNew = NULL;
	hashPrevSize = 0;
	hashNewSize = 0;

	strcpy(engineDirectory, baseDirectory);
	strcat(engineDirectory, "engines");

	hashNewSize = 65536;

	hashNew = (char*)malloc(hashNewSize);

	memset(hashNew, 0, hashNewSize);

	strcpy(hashNew, "");

	if ((dp = opendir(engineDirectory)))
	{
		while ((dirp = readdir(dp)))
		{
			if (dirp->d_type == DT_REG)
			{
				if (!strcmp(dirp->d_name, "hash") || !strcmp(dirp->d_name, "list")) continue;

				strcpy(filename, engineDirectory);
				strcat(filename, "/");
				strcat(filename, dirp->d_name);

				file = fopen(filename, "rb");

				if (!file) continue;

				fstat(fileno(file), &fileStat);
				fclose(file);

				sprintf(temp, "%s %i %8.8x\n", dirp->d_name, fileStat.st_size, (unsigned int)fileStat.st_mtime);

				if ((int)(strlen(hashNew) + strlen(temp)) >= hashNewSize)
				{
					hashNewSize += 65536;
					hashNew = (char*)realloc(hashNew, hashNewSize);
				}
				
				strcat(hashNew, temp);
			}
		}

		closedir(dp);
	}

	strcpy(hashname, engineDirectory);
	strcat(hashname, "/hash");
	strcpy(listname, engineDirectory);
	strcat(listname, "/list");

	refresh = true;

	file = fopen(listname, "rb");

	if (file)
	{
		fclose(file);

		file = fopen(hashname, "rb");

		if (file)
		{
			fseek(file, 0, SEEK_END);
			hashPrevSize = ftell(file);
			fseek(file, 0, SEEK_SET);

			hashPrev = (char*)malloc(hashPrevSize);

			fread(hashPrev, hashPrevSize, 1, file);
			fclose(file);

			if (!strcmp(hashPrev, hashNew)) refresh = false;
		}
	}
	
	if (refresh)
	{
		file = fopen(hashname, "wb");

		if (file)
		{
			fwrite(hashNew, strlen(hashNew)+1, 1, file);
			fclose(file);
		}

		refresh_engine_list();
	}
	
	if (hashPrev) free(hashPrev);
	if (hashNew) free(hashNew);
}



void free_select_engine_list(void)
{
	selectEngineFileList.clear();
	selectEngineTitleList.clear();
	selectEngineAboutList.clear();

	strcpy(selectEngineTitle,"");
	strcpy(selectEngineAbout,"");

	selectEngineCount=0;
}



void select_engine_update_info(void)
{
	if(!selectEngineCount) return;

	strcpy(selectEngineTitle, selectEngineTitleList[selectEngineCursor].c_str());
	strcpy(selectEngineAbout, selectEngineAboutList[selectEngineCursor].c_str());
}



void set_select_engine(void)
{
	char listname[MAXPATH], filename[MAXPATH];
	FILE *file;
	int i;

	check_engine_updates();

	free_select_engine_list();

	strcpy(listname, baseDirectory);
	strcat(listname, "engines/list");

	file = fopen(listname, "r");

	if (!file) critical_error("[SYS] Can't open engine list");

	while (1)
	{
		if (!fgets(filename, sizeof(filename), file)) break;

		for (i = 0;i < (int)strlen(filename);++i) if (filename[i] < 32) filename[i] = 0;
		
		fgets(selectEngineTitle, sizeof(selectEngineTitle), file);

		selectEngineFileList.push_back(filename);
		selectEngineTitleList.push_back(selectEngineTitle);

		strcpy(selectEngineAbout, "");

		while (1)
		{
			if (!fgets(filename, sizeof(filename), file)) break;
			if (!memcmp(filename, "###",3)) break;

			strcat(selectEngineAbout, filename);
		}

		selectEngineAboutList.push_back(selectEngineAbout);

		++selectEngineCount;
	}

	fclose(file);

	selectEngineCursor=0;

	for(i=0;i<selectEngineCount;++i)
	{
		if(!strcmp(engineFileName,selectEngineFileList[i].c_str()))
		{
			selectEngineCursor=i;
			break;
		}
	}

	select_engine_update_info();

	set_edit_mode(MODE_SELECT_ENGINE);
}



void draw_select_engine(void)
{
	char buf[MAX_TEXT_WDT];
	int i, j, x, xs, y, offset, offseti, color, off;
	const char *str;

	for(i=0;i<textScreenWidth;++i)
	{
		PUT_ATTR(i,0,COL_HEADER);
		PUT_ATTR(i,textScreenHeight-1,COL_HEADER);
	}

	for(i=0;i<PATTERN_HEIGHT/2-1;++i)
	{
		for(j=0;j<textScreenWidth;++j)
		{
			PUT_ATTR(j,PATTERN_YPOS+i,COL_PATTERN_BEAT);
		}
	}

	sprintf(buf, "Select engine (%i found)", selectEngineCount);

	put_str(1, 0, buf, COL_HEADER);
	put_str(1, textScreenHeight - 1, "~Ctrl+Enter~ change engine (unsaved data will be irreversibly changed!)", COL_HEADER);

	if(!selectEngineCount)
	{
		put_str(PATTERN_XPOS+1,PATTERN_YPOS+1,"No engines found",COL_CURSOR_ROW);

		return;
	}

	off = 0;
	
	for (i = (int)strlen(selectEngineTitle) - 1;i>=0;--i)
	{
		if (selectEngineTitle[i] == '|')
		{
			off = i + 1;
			break;
		}
	}
	
	sprintf(buf, "Engine: %s (%s)", &selectEngineTitle[off], selectEngineFileList[selectEngineCursor].c_str());

	put_str(PATTERN_XPOS+1,PATTERN_YPOS+1, buf,COL_PATTERN_BEAT);

	put_str_wrap(selectEngineAbout, PATTERN_XPOS + 1, PATTERN_YPOS + 3, textScreenWidth - 2, PATTERN_HEIGHT / 2 - 1);

	y=PATTERN_HEIGHT/2;

	if(selectEngineCount<ENGINE_LIST_HEIGHT)
	{ 
		offset = 0;
	}
	else
	{
		offset = selectEngineCursor - ENGINE_LIST_HEIGHT / 2;

		if (offset > selectEngineCount - ENGINE_LIST_HEIGHT) offset = selectEngineCount - ENGINE_LIST_HEIGHT;

		if (offset < 0) offset = 0;
	}

	offseti = offset;

	for(i=0;i<ENGINE_LIST_HEIGHT;++i)
	{
		if (offset >= selectEngineCount) break;

		if (!strcmp(engineFileName, selectEngineFileList[offset].c_str())) PUT_CHAR(PATTERN_XPOS + 3, y, '*');

		color = (offset == selectEngineCursor) ? COL_CURSOR_ROW : COL_PROGRAM_BACKGROUND;

		str = selectEngineTitleList[offset].c_str();

		x = PATTERN_XPOS + 4;

		put_str(x, y, offset == selectEngineCursor ? ">" : " ", color);

		++x;

		for (j = 0;j < (int)strlen(str);++j)
		{
			if (str[j] == '|')
			{
				if (x < PATTERN_XPOS + 5 + 5) xs = PATTERN_XPOS + 5 + 5; else xs = PATTERN_XPOS + 5 + 11;

				while(x<xs)
				{
					PUT_CHAR(x, y, ' ');
					PUT_ATTR(x, y, color);

					++x;
				}

				continue;
			}

			PUT_CHAR(x, y, str[j]);
			PUT_ATTR(x, y, color);

			++x;
		}

		put_str(x, y, " ", color);

		++y;
		++offset;
	}

	PUT_CHAR(PATTERN_XPOS + 1, PATTERN_HEIGHT / 2 + 1, offseti ? 16 : ' ');
	PUT_CHAR(PATTERN_XPOS + 1, textScreenHeight - 3, offseti < (selectEngineCount - ENGINE_LIST_HEIGHT) ? 17 : ' ');
}



void move_select_engine_cursor(int offset)
{
	selectEngineCursor+=offset;

	if(selectEngineCursor<0) selectEngineCursor=0;
	if(selectEngineCursor>=selectEngineCount-1) selectEngineCursor=selectEngineCount-1;

	select_engine_update_info();
}



void select_new_engine(void)
{
	int i,j,k,note,noteSrcColumn,noteDstColumn;

	strcpy(engineFileName,selectEngineFileList[selectEngineCursor].c_str());

	set_undo();
	module_clear();
	change_engine();

	noteSrcColumn=0;

	for(i=0;i<moduleUndo.columns;++i)
	{
		if(moduleUndo.columnType[i]==COLUMN_TYPE_NOTE)
		{
			noteDstColumn=0;

			for(j=0;j<module.columns;++j)
			{
				if(module.columnType[j]==COLUMN_TYPE_NOTE)
				{
					if(noteDstColumn==noteSrcColumn)
					{
						for(k=0;k<MAX_ROWS;++k)
						{
							note=moduleUndo.rows[k].column[i];

							if(note>1)
							{
								if(note<module.lowestNote) note=module.lowestNote;
								if(note>module.highestNote) note=module.highestNote;
							}

							module.rows[k].column[j]=note;
						}

						break;
					}

					++noteDstColumn;
				}
			}

			++noteSrcColumn;
		}
	}

	for (i = 0; i < MAX_ROWS; ++i)
	{
		module.marker[i] = moduleUndo.marker[i];
		strcpy(module.markerName[i], moduleUndo.markerName[i]);
	}

	module.loopStart=moduleUndo.loopStart;
	module.loopEnd  =moduleUndo.loopEnd;
	module.speed    =moduleUndo.speed;
	module.measure  =moduleUndo.measure;

	strcpy(module.title ,moduleUndo.title);
	strcpy(module.author,moduleUndo.author);

	set_edit_mode(MODE_EDIT_SONG);
}



void select_engine_events(SDL_Event event)
{
	switch(event.type)
	{
	case SDL_KEYDOWN:
		{
			switch(event.key.keysym.sym)
			{
			case SDLK_ESCAPE:
				{
					change_engine();
					set_edit_mode(MODE_EDIT_SONG);
				}
				break;

			case SDLK_UP:
				{
					move_select_engine_cursor(-1);
				}
				break;

			case SDLK_DOWN:
				{
					move_select_engine_cursor(1);
				}
				break;

			case SDLK_PAGEUP:
				{
					move_select_engine_cursor(-10);
				}
				break;

			case SDLK_PAGEDOWN:
				{
					move_select_engine_cursor(10);
				}
				break;

			case SDLK_HOME:
				{
					selectEngineCursor=0;
					select_engine_update_info();
				}
				break;

			case SDLK_END:
				{
					selectEngineCursor=selectEngineCount-1;
					select_engine_update_info();
				}
				break;

			case SDLK_RETURN:
				{
					if(event.key.keysym.mod&(KMOD_LCTRL|KMOD_RCTRL))
					{
						select_new_engine();
					}
				}
				break;
			}
		}
		break;
	}
}