int selectFileReturnMode;

vector<string> selectFile=vector<string>();
int selectFileCount;
int selectFileCursor;
const char* selectFileHeader = NULL;
char selectFilePath[MAXPATH] = "\0";
char selectFileFile[MAXPATH] = "\0";
char *selectFileLast = NULL;
char selectFileFileCopy[MAXPATH] = "\0";
char* selectFileOriginalPath = NULL;
char selectFileFilter[MAXPATH] = "\0";
bool selectFileDirectories;
bool selectFileSaveMode;
bool selectFileShowOverwrite;
bool selectFileOverwrite;
char selectFilePrevDir[MAXPATH] = "\0";
int selectFileEvent;

char selectFileSongLast[MAXPATH] = "\0";
char selectFileInstrumentLast[MAXPATH] = "\0";
char selectFileImportLast[MAXPATH] = "\0";
char selectFileExportLast[MAXPATH] = "\0";



void free_file_list(void)
{
	selectFile.clear();
	selectFileCount=0;
}



void build_file_list(void)
{
	char tempName[MAXPATH];
	DIR *dp;
	struct dirent *dirp;
	int i,cursor;

	cursor=-1;

	if(selectFileDirectories)
	{
		dp = opendir(selectFilePath);

		if(dp)
		{
			while(1)
			{
				dirp = readdir(dp);

				if (!dirp) break;

				if(dirp->d_type==DT_DIR)
				{
					if(strcmp(dirp->d_name,"."))
					{
						selectFile.push_back("!"+string(dirp->d_name));

						if(!strcmp(dirp->d_name,selectFilePrevDir)) cursor=selectFileCount;

						++selectFileCount;
					}
				}
			}

			closedir(dp);
		}
	}

	dp = opendir(selectFilePath);

	if(dp)
	{
		while(1)
		{
			dirp = readdir(dp);

			if (!dirp) break;

			if(dirp->d_type==DT_REG)
			{
				strcpy(tempName,dirp->d_name);

				for(i=strlen(tempName)-1;i>=0;--i)
				{
					if(tempName[i]!=' ') break;

					tempName[i]=0;
				}

				if(!strcmp(&tempName[strlen(dirp->d_name)-strlen(selectFileFilter)],selectFileFilter))
				{
					selectFile.push_back(" "+string(tempName));

					if (!strcmp(dirp->d_name, selectFileLast)) cursor = selectFileCount;

					++selectFileCount;
				}
			}
		}

		closedir(dp);
	}

	if(selectFileSaveMode)
	{
		selectFile.push_back("*[New file]");

		++selectFileCount;
	}

	if (cursor >= 0) selectFileCursor = cursor;

	if (selectFileCursor >= selectFileCount) selectFileCursor = 0;
}



void set_select_file(const char* header,char* path,int mode,const char* filter,bool dirs,int event,char *last)
{
	unsigned int i;

	selectFileLast = last;
	selectFileReturnMode=mode;
	selectFileHeader=header;
	selectFileOriginalPath=path;
	strcpy(selectFileFilter,filter);
	selectFileDirectories=dirs;
	selectFileSaveMode = (event != EVENT_LOAD_SONG&&event != EVENT_LOAD_INSTRUMENT&&event != EVENT_SCRIPT_FILE_SELECT ? true : false);
	selectFileShowOverwrite=false;
	selectFileEvent=event;

	strcpy(selectFilePath,path);
	strcpy(selectFileFile,"untitled");
	strcat(selectFileFile,filter);
	strcpy(selectFilePrevDir,"");

	for(i=0;i<strlen(selectFilePath);++i) if(selectFilePath[i]=='\\') selectFilePath[i]='/';

	free_file_list();
	build_file_list();

	set_edit_mode(MODE_SELECT_FILE);
}



int get_file_list_top_row(void)
{
	int file;

	if (selectFileCount > PATTERN_HEIGHT)
	{
		file = selectFileCursor - PATTERN_HEIGHT / 2;

		if (file < 0) file = 0;

		if (file > selectFileCount - PATTERN_HEIGHT) file = selectFileCount - PATTERN_HEIGHT;
	}
	else
	{
		file = 0;
	}

	return file;
}



void draw_select_file(void)
{
	int i,file;
	unsigned char color;
	const char *str;

	color=selectFileSaveMode?COL_HEADER_MUTE:COL_HEADER;

	for(i=0;i<textScreenWidth;++i)
	{
		PUT_ATTR(i,0,color);
		PUT_ATTR(i,textScreenHeight-1,color);
	}

	put_str(1,0,(char*)selectFileHeader,color);
	put_str(1,textScreenHeight-1,selectFilePath,color);

	file=get_file_list_top_row();

	for(i=0;i<PATTERN_HEIGHT;++i)
	{
		if(file>=selectFileCount) break;

		color=COL_PROGRAM_BACKGROUND;

		if(selectFile[file].c_str()[0]=='!') color=COL_DIRECTORY;

		if(file==selectFileCursor) color=COL_CURSOR_ROW;

		str = &selectFile[file].c_str()[1];

		put_str_file(PATTERN_XPOS, PATTERN_YPOS + i, file == selectFileCursor ? ">" : " ", color);
		put_str_file(PATTERN_XPOS + 1, PATTERN_YPOS + i, (char*)str, color);
		put_str_file(PATTERN_XPOS + 1 + strlen(str), PATTERN_YPOS + i, " ", color);

		++file;
	}

	if(selectFileShowOverwrite)
	{
		put_str(PATTERN_XPOS,PATTERN_XPOS+1+selectFileCursor-get_file_list_top_row()," File already exists, overwrite? (Y/N) ",COL_CURSOR);
	}
}



void move_file_list_cursor(int offset)
{
	selectFileCursor+=offset;

	if(selectFileCursor<0) selectFileCursor=0;
	if(selectFileCursor>=selectFileCount-1) selectFileCursor=selectFileCount-1;
}



void select_file_done(void)
{
	SDL_Event userEvent;

	if(selectFileEvent==EVENT_LOAD_SONG) module.columns=0;

	strcpy(selectFileOriginalPath,selectFilePath);

	free_file_list();

	set_edit_mode(selectFileReturnMode);

	userEvent.type=SDL_USEREVENT;
	userEvent.user.code=selectFileEvent;
	userEvent.user.data1=selectFileFile;

	SDL_PushEvent(&userEvent);
}



bool file_exists(char* filename)
{
	FILE *file;

	file=fopen(filename,"rb");

	if(file)
	{
		fclose(file);
		return true;
	}

	return false;
}



void file_list_add_extension(char* filename)
{
	if(!strcmp(&filename[strlen(filename)-strlen(selectFileFilter)],selectFileFilter)) return;

	strcat(filename,selectFileFilter);
}



void select_file_events(SDL_Event event)
{
	unsigned int i;

	if(editMode==MODE_SELECT_FILE_INPUT_DONE)
	{
		if(inputDone)
		{
			strcpy(selectFileFileCopy,selectFileFile);
			strcpy(selectFileFile,selectFilePath);
			strcat(selectFileFile,selectFileFileCopy);

			file_list_add_extension(selectFileFile);

			strcpy(selectFileLast, selectFileFileCopy);
			file_list_add_extension(selectFileLast);

			set_edit_mode(MODE_SELECT_FILE_OVERWRITE);
		}
	}

	if(editMode==MODE_SELECT_FILE_OVERWRITE)
	{
		file_list_add_extension(selectFileFile);

		if(!file_exists(selectFileFile))
		{
			select_file_done();
		}
		else
		{
			set_edit_mode(MODE_SELECT_FILE);
			selectFileShowOverwrite=true;
		}

		return;
	}

	switch(event.type)
	{
	case SDL_KEYDOWN:
		{
			if(selectFileShowOverwrite)
			{
				switch(event.key.keysym.sym)
				{
				case SDLK_y:
					{
						select_file_done();
					}
					break;

				case SDLK_n:
					{
						strcpy(selectFileFile,selectFileFileCopy);
						selectFileShowOverwrite=false;
					}
					break;
				}
			}
			else
			{
				switch(event.key.keysym.sym)
				{
				case SDLK_ESCAPE:
					{
						strcpy(selectFileFile,"");
						free_file_list();
						set_edit_mode(selectFileReturnMode);
					}
					break;

				case SDLK_RETURN:
					{
						if(selectFileSaveMode)
						{
							if(selectFile[selectFileCursor].c_str()[0]=='*')
							{
								set_input_string(PATTERN_XPOS+1,PATTERN_YPOS+1+selectFileCursor-get_file_list_top_row(),textScreenWidth-2,MODE_SELECT_FILE_INPUT_DONE,true,selectFileFile);
								break;
							}
						}

						if(selectFile[selectFileCursor].c_str()[0]=='!')	//a directory
						{
							if(!strcmp(&selectFile[selectFileCursor].c_str()[1],".."))	//go up a directory
							{
								i=strlen(selectFilePath)-1;

								while(i)
								{
									--i;

									if(selectFilePath[i]=='/'||selectFilePath[i]=='\\')
									{
										strcpy(selectFilePrevDir,&selectFilePath[i+1]);
										selectFilePrevDir[strlen(selectFilePrevDir)-1]=0;

										selectFilePath[i+1]=0;

										break;
									}
								}
							}
							else
							{
								strcat(selectFilePath,&selectFile[selectFileCursor].c_str()[1]);
								strcat(selectFilePath,"/");
							}

							free_file_list();
							build_file_list();

							selectFileCursor=selectFileSaveMode?selectFileCount-1:0;
						}
						else
						{
							strcpy(selectFileFile,selectFilePath);
							strcat(selectFileFile,&selectFile[selectFileCursor].c_str()[1]);
							strcpy(selectFileLast, selectFileFile);

							if(selectFileSaveMode)
							{
								set_edit_mode(MODE_SELECT_FILE_OVERWRITE);
							}
							else
							{
								select_file_done();
							}
						}
					}
					break;

				case SDLK_UP:
					{
						move_file_list_cursor(-1);
					}
					break;

				case SDLK_DOWN:
					{
						move_file_list_cursor(1);
					}
					break;

				case SDLK_PAGEUP:
					{
						move_file_list_cursor(-PATTERN_HEIGHT);
					}
					break;

				case SDLK_PAGEDOWN:
					{
						move_file_list_cursor(PATTERN_HEIGHT);
					}
					break;

				case SDLK_HOME:
					{
						selectFileCursor=0;
					}
					break;

				case SDLK_END:
					{
						selectFileCursor=selectFileCount-1;
					}
					break;
				}
			}
		}
		break;
	}
}